| Flutter Impeller |

Public Types | Public Member Functions | List of all members
impeller::DlPlayground Class Reference

`#include <dl_playground.h>`

Inheritance diagram for impeller::DlPlayground:

## Public Types
using | DisplayListPlaygroundCallback = std::function< sk_sp< flutter::DisplayList >()>
Public Types inherited from impeller::Playground
using | SinglePassCallback = std::function< bool(RenderPass &pass)>

## Public Member Functions
| DlPlayground ()
| ~DlPlayground ()
bool | OpenPlaygroundHere (flutter::DisplayListBuilder &builder)
bool | OpenPlaygroundHere (sk_sp< flutter::DisplayList > list)
bool | OpenPlaygroundHere (DisplayListPlaygroundCallback callback)
SkFont | CreateTestFontOfSize (SkScalar scalar)
SkFont | CreateTestFont ()
Public Member Functions inherited from impeller::PlaygroundTest
| PlaygroundTest ()
virtual | ~PlaygroundTest ()
void | SetUp () override
void | TearDown () override
PlaygroundBackend | GetBackend () const
std::unique_ptr< fml::Mapping > | OpenAssetAsMapping (std::string asset_name) const override
std::shared_ptr< RuntimeStage > | OpenAssetAsRuntimeStage (const char *asset_name) const
std::string | GetWindowTitle () const override
Public Member Functions inherited from impeller::Playground
| Playground (PlaygroundSwitches switches)
virtual | ~Playground ()
void | SetupContext (PlaygroundBackend backend)
void | SetupWindow ()
void | TeardownWindow ()
Point | GetCursorPosition () const
ISize | GetWindowSize () const
Point | GetContentScale () const
Scalar | GetSecondsElapsed () const
| Get the amount of time elapsed from the start of the playground's execution. More...
std::shared_ptr< Context > | GetContext () const
bool | OpenPlaygroundHere (const Renderer::RenderCallback &render_callback)
bool | OpenPlaygroundHere (SinglePassCallback pass_callback)
std::shared_ptr< Texture > | CreateTextureForFixture (const char *fixture_name, bool enable_mipmapping=false) const
std::shared_ptr< Texture > | CreateTextureCubeForFixture (std::array< const char *, 6 > fixture_names) const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Playground
static bool | ShouldOpenNewPlaygrounds ()
static std::shared_ptr< CompressedImage > | LoadFixtureImageCompressed (std::shared_ptr< fml::Mapping > mapping)
static std::optional< DecompressedImage > | DecodeImageRGBA (const std::shared_ptr< CompressedImage > &compressed)
static std::shared_ptr< Texture > | CreateTextureForMapping (const std::shared_ptr< Context > &context, std::shared_ptr< fml::Mapping > mapping, bool enable_mipmapping=false)
static bool | SupportsBackend (PlaygroundBackend backend)
Protected Attributes inherited from impeller::Playground
const PlaygroundSwitches | switches_

## Detailed Description

Definition at line 15 of file dl_playground.h.

## Member Typedef Documentation

## ◆ DisplayListPlaygroundCallback

using impeller::DlPlayground::DisplayListPlaygroundCallback = std::function<sk_sp<flutter::DisplayList>()>

Definition at line 18 of file dl_playground.h.

## Constructor & Destructor Documentation

## ◆ DlPlayground()

impeller::DlPlayground::DlPlayground | ( |  | ) |
| default

## ◆ ~DlPlayground()

impeller::DlPlayground::~DlPlayground | ( |  | ) |
| default

## Member Function Documentation

## ◆ CreateTestFont()

SkFont impeller::DlPlayground::CreateTestFont | ( |  | ) |

Definition at line 77 of file dl_playground.cc.

77 {
78 return CreateTestFontOfSize(50);
79 }

References CreateTestFontOfSize().

## ◆ CreateTestFontOfSize()

SkFont impeller::DlPlayground::CreateTestFontOfSize | ( | SkScalar | scalar | ) |

Definition at line 70 of file dl_playground.cc.

70 {
71 static constexpr const char* kTestFontFixture = "Roboto-Regular.ttf";
72 auto mapping = OpenFixtureAsSkData(kTestFontFixture);
73 FML_CHECK(mapping);
74 return SkFont{SkTypeface::MakeFromData(mapping), scalar};
75 }

References impeller::OpenFixtureAsSkData().

Referenced by CreateTestFont().

## ◆ OpenPlaygroundHere() [1/3]

bool impeller::DlPlayground::OpenPlaygroundHere | ( | DisplayListPlaygroundCallback | callback | ) |

Definition at line 28 of file dl_playground.cc.

28 {
29 if (!switches_.enable_playground) {
30 return true;
31 }
32
33 AiksContext context(GetContext(), TypographerContextSkia::Make());
34 if (!context.IsValid()) {
35 return false;
36 }
37 return Playground::OpenPlaygroundHere(
38 [&context, &callback](RenderTarget& render_target) -> bool {
39 static bool wireframe = false;
40 if (ImGui::IsKeyPressed(ImGuiKey_Z)) {
41 wireframe = !wireframe;
42 context.GetContentContext().SetWireframe(wireframe);
43 }
44
45 auto list = callback();
46
47 DlDispatcher dispatcher;
48 list->Dispatch(dispatcher);
49 auto picture = dispatcher.EndRecordingAsPicture();
50
51 return context.Render(picture, render_target);
52 });
53 }

References impeller::PlaygroundSwitches::enable_playground, impeller::DlDispatcher::EndRecordingAsPicture(), impeller::AiksContext::GetContentContext(), impeller::Playground::GetContext(), impeller::AiksContext::IsValid(), impeller::TypographerContextSkia::Make(), impeller::Playground::OpenPlaygroundHere(), impeller::AiksContext::Render(), and impeller::Playground::switches_.

## ◆ OpenPlaygroundHere() [2/3]

bool impeller::DlPlayground::OpenPlaygroundHere | ( | flutter::DisplayListBuilder & | builder | ) |

Definition at line 20 of file dl_playground.cc.

20 {
21 return OpenPlaygroundHere(builder.Build());
22 }

Referenced by OpenPlaygroundHere().

## ◆ OpenPlaygroundHere() [3/3]

bool impeller::DlPlayground::OpenPlaygroundHere | ( | sk_sp< flutter::DisplayList > | list | ) |

Definition at line 24 of file dl_playground.cc.

24 {
25 return OpenPlaygroundHere([&list]() { return list; });
26 }

References OpenPlaygroundHere().

The documentation for this class was generated from the following files:

- impeller/display_list/dl_playground.h
- impeller/display_list/dl_playground.cc

impeller::DlPlayground::OpenPlaygroundHere
bool OpenPlaygroundHere(flutter::DisplayListBuilder &builder)
Definition: dl_playground.cc:20
impeller::DlPlayground::CreateTestFontOfSize
SkFont CreateTestFontOfSize(SkScalar scalar)
Definition: dl_playground.cc:70
impeller::Playground::switches_
const PlaygroundSwitches switches_
Definition: playground.h:91
impeller::OpenFixtureAsSkData
static sk_sp< SkData > OpenFixtureAsSkData(const char *fixture_name)
Definition: dl_playground.cc:55
impeller::Playground::OpenPlaygroundHere
bool OpenPlaygroundHere(const Renderer::RenderCallback &render_callback)
Definition: playground.cc:189
impeller::Playground::GetContext
std::shared_ptr< Context > GetContext() const
Definition: playground.cc:86
impeller::PlaygroundSwitches::enable_playground
bool enable_playground
Definition: switches.h:16
impeller::TypographerContextSkia::Make
static std::shared_ptr< TypographerContext > Make()
Definition: typographer_context_skia.cc:30